/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_sil.h 240 2009-04-30 04:31:17Z ertl-honda $
 */

/*
 *  sil.hΥץå¸Nios2ѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

/*
 *  ץåΥǥ
 */
#define SIL_ENDIAN_LITTLE

#ifndef TOPPERS_MACRO_ONLY

/*
 *  NMI٤Ƥγߤζػ
 */
Inline uint8_t
TOPPERS_disint(void)
{
	uint32_t  TOPPERS_status;

	Asm("rdctl %0, status" : "=r" (TOPPERS_status));
	Asm("wrctl status, %0" :: "r" (TOPPERS_status & ~(0x0001)) : "memory");
    return((uint8_t)(TOPPERS_status & (0x0001)));
}

/*
 *  ͥ٥ޥɽˤθͤ
 */
Inline void
TOPPERS_set_pie(uint8_t TOPPERS_pie_bit)
{
	uint32_t  TOPPERS_status;

	Asm("rdctl %0, status" : "=r" (TOPPERS_status));
	TOPPERS_status = TOPPERS_status & ~(0x0001);
	TOPPERS_status = TOPPERS_status | (TOPPERS_pie_bit & (0x0001));
	Asm("wrctl status, %0" :: "r" (TOPPERS_status) : "memory");
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC      uint8_t TOPPERS_pie_bit
#define SIL_LOC_INT()    ((void)(TOPPERS_pie_bit = TOPPERS_disint()))
#define SIL_UNL_INT()    (TOPPERS_set_pie(TOPPERS_pie_bit))

/*
 *  Ԥprc_support.S
 */
extern void sil_dly_nse(ulong_t dlytim);


/*
 *  I/O֥ؿ
 *  Nios2I/O֤ȥ֤϶̤ʤå̵ˤ뤿ᡤ
 *  I/OϤδؿѤ뤳ȤȤ롥
 */

/*
 *  8ӥåñ̤ɽФ
 */
Inline uint8_t
sil_reb_iop(void *mem)
{
	return(__builtin_ldbuio(mem));
}

Inline void
sil_wrb_iop(void *mem, uint8_t data)
{
	__builtin_stbio(mem, data);
}

/*
 *  16ӥåñ̤ɽФ
 */
Inline uint16_t
sil_reh_iop(void *mem)
{
	return(__builtin_ldhuio(mem));
}

Inline void
sil_wrh_iop(void *mem, uint16_t data)
{
	__builtin_sthio(mem, data);
}

/*
 *  32ӥåñ̤ɽФ
 */
Inline uint32_t
sil_rew_iop(void *mem)
{
	return(__builtin_ldwio(mem));
}

Inline void
sil_wrw_iop(void *mem, uint32_t data)
{
	__builtin_stwio(mem, data);
}

/*
 *  ԥåμsilѤǤʤΤľܥ
 */
Inline void
TOPPERS_sil_loc_spn(void)
{
	Asm("":::"memory");
}

/*
 *  ԥåβ
 */
Inline void
TOPPERS_sil_unl_spn(void)
{
	Asm("":::"memory");
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() TOPPERS_sil_loc_spn()
#define SIL_UNL_SPN() TOPPERS_sil_unl_spn()

/*
 *  ץåIDμ
 */
Inline void
sil_get_pid(ID *p_prcid)
{
	uint32_t index;

	Asm("rdctl %0, cpuid" : "=r" (index));
	*p_prcid = index + 1;
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
