/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: pridataq.c 333 2009-07-17 04:13:48Z ertl-honda $
 */

/*
 *		ͥ٥ǡ塼ǽ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "pridataq.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_SND_PDQ_ENTER
#define LOG_SND_PDQ_ENTER(pdqid, data, datapri)
#endif /* LOG_SND_PDQ_ENTER */

#ifndef LOG_SND_PDQ_LEAVE
#define LOG_SND_PDQ_LEAVE(ercd)
#endif /* LOG_SND_PDQ_LEAVE */

#ifndef LOG_PSND_PDQ_ENTER
#define LOG_PSND_PDQ_ENTER(pdqid, data, datapri)
#endif /* LOG_PSND_PDQ_ENTER */

#ifndef LOG_PSND_PDQ_LEAVE
#define LOG_PSND_PDQ_LEAVE(ercd)
#endif /* LOG_PSND_PDQ_LEAVE */

#ifndef LOG_IPSND_PDQ_ENTER
#define LOG_IPSND_PDQ_ENTER(pdqid, data, datapri)
#endif /* LOG_IPSND_PDQ_ENTER */

#ifndef LOG_IPSND_PDQ_LEAVE
#define LOG_IPSND_PDQ_LEAVE(ercd)
#endif /* LOG_IPSND_PDQ_LEAVE */

#ifndef LOG_TSND_PDQ_ENTER
#define LOG_TSND_PDQ_ENTER(pdqid, data, datapri, tmout)
#endif /* LOG_TSND_PDQ_ENTER */

#ifndef LOG_TSND_PDQ_LEAVE
#define LOG_TSND_PDQ_LEAVE(ercd)
#endif /* LOG_TSND_PDQ_LEAVE */

#ifndef LOG_RCV_PDQ_ENTER
#define LOG_RCV_PDQ_ENTER(pdqid, p_data, p_datapri)
#endif /* LOG_RCV_PDQ_ENTER */

#ifndef LOG_RCV_PDQ_LEAVE
#define LOG_RCV_PDQ_LEAVE(ercd, data, datapri)
#endif /* LOG_RCV_PDQ_LEAVE */

#ifndef LOG_PRCV_PDQ_ENTER
#define LOG_PRCV_PDQ_ENTER(pdqid, p_data, p_datapri)
#endif /* LOG_PRCV_PDQ_ENTER */

#ifndef LOG_PRCV_PDQ_LEAVE
#define LOG_PRCV_PDQ_LEAVE(ercd, data, datapri)
#endif /* LOG_PRCV_PDQ_LEAVE */

#ifndef LOG_TRCV_PDQ_ENTER
#define LOG_TRCV_PDQ_ENTER(pdqid, p_data, p_datapri, tmout)
#endif /* LOG_TRCV_PDQ_ENTER */

#ifndef LOG_TRCV_PDQ_LEAVE
#define LOG_TRCV_PDQ_LEAVE(ercd, data, datapri)
#endif /* LOG_TRCV_PDQ_LEAVE */

#ifndef LOG_INI_PDQ_ENTER
#define LOG_INI_PDQ_ENTER(pdqid)
#endif /* LOG_INI_PDQ_ENTER */

#ifndef LOG_INI_PDQ_LEAVE
#define LOG_INI_PDQ_LEAVE(ercd)
#endif /* LOG_INI_PDQ_LEAVE */

#ifndef LOG_REF_PDQ_ENTER
#define LOG_REF_PDQ_ENTER(pdqid, pk_rpdq)
#endif /* LOG_REF_PDQ_ENTER */

#ifndef LOG_REF_PDQ_LEAVE
#define LOG_REF_PDQ_LEAVE(ercd, pk_rpdq)
#endif /* LOG_REF_PDQ_LEAVE */

/*
 *  ͥ٥ǡ塼ο
 */
#define tnum_pdq	((uint_t)(tmax_pdqid - TMIN_PDQID + 1))

/*
 *  ͥ٥ǡ塼IDͥ٥ǡ塼֥åФ
 *  Υޥ
 */
#define INDEX_PDQ(pdqid)	((uint_t)((pdqid) - TMIN_PDQID))
#define get_pdqcb(pdqid)	(p_pdqcb_table[INDEX_PDQ(pdqid)])

/*
 *  ͥ٥ǡ塼ǽν
 */
#ifdef TOPPERS_pdqini

void
initialize_pridataq(void)
{
	uint_t	i;
	PDQCB	*p_pdqcb;

	if (x_sense_mprc()) {
		for (i = 0; i < tnum_pdq; i++) {
			p_pdqcb = p_pdqcb_table[i];
			queue_initialize(&(p_pdqcb->swait_queue));
			p_pdqcb->p_pdqinib = &(pdqinib_table[i]);
			queue_initialize(&(p_pdqcb->rwait_queue));
			p_pdqcb->count = 0U;
			p_pdqcb->p_head = NULL;
			p_pdqcb->unused = 0U;
			p_pdqcb->p_freelist = NULL;
#if TTYPE_KLOCK == F_KLOCK
			initialize_obj_lock(&(p_pdqcb->obj_lock));
#endif /* TTYPE_KLOCK == F_KLOCK */
		}
	}
}

#endif /* TOPPERS_pdqini */

/*
 *  ͥ٥ǡ塼ΰؤΥǡγǼ
 */
#ifdef TOPPERS_pdqenq

void
enqueue_pridata(PDQCB *p_pdqcb, intptr_t data, PRI datapri)
{
	PDQMB	*p_pdqmb;
	PDQMB	**pp_prev_next, *p_next;

	if (p_pdqcb->p_freelist != NULL) {
		p_pdqmb = p_pdqcb->p_freelist;
		p_pdqcb->p_freelist = p_pdqmb->p_next;
	}
	else {
		p_pdqmb = p_pdqcb->p_pdqinib->p_pdqmb + p_pdqcb->unused;
		p_pdqcb->unused++;
	}

	p_pdqmb->data = data;
	p_pdqmb->datapri = datapri;

	pp_prev_next = &(p_pdqcb->p_head);
	while ((p_next = *pp_prev_next) != NULL) {
		if (p_next->datapri > datapri) {
			break;
		}
		pp_prev_next = &(p_next->p_next);
	}
	p_pdqmb->p_next = p_next;
	*pp_prev_next = p_pdqmb;
	p_pdqcb->count++;
}

#endif /* TOPPERS_pdqenq */

/*
 *  ͥ٥ǡ塼ΰ褫ΥǡμФ
 */
#ifdef TOPPERS_pdqdeq

void
dequeue_pridata(PDQCB *p_pdqcb, intptr_t *p_data, PRI *p_datapri)
{
	PDQMB	*p_pdqmb;

	p_pdqmb = p_pdqcb->p_head;
	p_pdqcb->p_head = p_pdqmb->p_next;
	p_pdqcb->count--;

	*p_data = p_pdqmb->data;
	*p_datapri = p_pdqmb->datapri;

	p_pdqmb->p_next = p_pdqcb->p_freelist;
	p_pdqcb->p_freelist = p_pdqmb;
}

#endif /* TOPPERS_pdqdeq */

/*
 *  ͥ٥ǡ塼ؤ
 */
#ifdef TOPPERS_snd_pdq

ER
snd_pdq(ID pdqid, intptr_t data, PRI datapri)
{
	PDQCB	*p_pdqcb;
	bool_t	dspreq = false;
	ER		ercd;
	TCB		*p_tcb;

	LOG_SND_PDQ_ENTER(pdqid, data, datapri);
	CHECK_DISPATCH();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);
	CHECK_PAR(TMIN_DPRI <= datapri && datapri <= p_pdqcb->p_pdqinib->maxdpri);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ*/
	if (!queue_empty(&(p_pdqcb->rwait_queue))) {
		p_tcb = (TCB *)(p_pdqcb->rwait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		p_tcb->winfo_obj.pdq.data = data;
		p_tcb->winfo_obj.pdq.datapri = datapri;
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);
		ercd = E_OK;
	}
	else if (p_pdqcb->count < p_pdqcb->p_pdqinib->pdqcnt) {
		enqueue_pridata(p_pdqcb, data, datapri);
		T_RELEASE_OBJ_LOCK(p_pdqcb);
		ercd = E_OK;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(p_pdqcb);
		my_p_runtsk->winfo_obj.pdq.data = data;
		my_p_runtsk->winfo_obj.pdq.datapri = datapri;
		my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_SPDQ);
		wobj_make_wait((WOBJCB *) p_pdqcb);
		T_RELEASE_NESTED_LOCK(my_p_runtsk->p_pcb);
		RELEASE_OBJ_LOCK(p_pdqcb);
		dispatch();
		ercd = my_p_runtsk->wercd;
		t_unlock_cpu();
	}

  error_exit:
	LOG_SND_PDQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_snd_pdq */

/*
 *  ͥ٥ǡ塼ؤʥݡ󥰡
 */
#ifdef TOPPERS_psnd_pdq

ER
psnd_pdq(ID pdqid, intptr_t data, PRI datapri)
{
	PDQCB	*p_pdqcb;
	bool_t	dspreq = false;
	ER		ercd;
	TCB		*p_tcb;

	LOG_PSND_PDQ_ENTER(pdqid, data, datapri);
	CHECK_TSKCTX_UNL();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);
	CHECK_PAR(TMIN_DPRI <= datapri && datapri <= p_pdqcb->p_pdqinib->maxdpri);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ*/
	if (!queue_empty(&(p_pdqcb->rwait_queue))) {
		p_tcb = (TCB *)(p_pdqcb->rwait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		p_tcb->winfo_obj.pdq.data = data;
		p_tcb->winfo_obj.pdq.datapri = datapri;
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		ercd = E_OK;
	}
	else if (p_pdqcb->count < p_pdqcb->p_pdqinib->pdqcnt) {
		enqueue_pridata(p_pdqcb, data, datapri);
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);

  error_exit:
	LOG_PSND_PDQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_psnd_pdq */

/*
 *  ͥ٥ǡ塼ؤʥݡ󥰡󥿥ƥѡ
 */
#ifdef TOPPERS_ipsnd_pdq

ER
ipsnd_pdq(ID pdqid, intptr_t data, PRI datapri)
{
	PDQCB	*p_pdqcb;
	ER		ercd;
	TCB		*p_tcb;

	LOG_IPSND_PDQ_ENTER(pdqid, data, datapri);
	CHECK_INTCTX_UNL();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);
	CHECK_PAR(TMIN_DPRI <= datapri && datapri <= p_pdqcb->p_pdqinib->maxdpri);

  retry:
	I_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ*/
	if (!queue_empty(&(p_pdqcb->rwait_queue))) {
		p_tcb = (TCB *)(p_pdqcb->rwait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		p_tcb->winfo_obj.pdq.data = data;
		p_tcb->winfo_obj.pdq.datapri = datapri;
		if (wait_complete(p_tcb)) {
			if (dispatch_request(p_tcb->p_pcb)) {
				my_reqflg = true;
			}
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		ercd = E_OK;
	}
	else if (p_pdqcb->count < p_pdqcb->p_pdqinib->pdqcnt) {
		enqueue_pridata(p_pdqcb, data, datapri);
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	I_RELEASE_OBJ_LOCK(p_pdqcb);

  error_exit:
	LOG_IPSND_PDQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_ipsnd_pdq */

/*
 *  ͥ٥ǡ塼ؤʥॢȤ
 */
#ifdef TOPPERS_tsnd_pdq

ER
tsnd_pdq(ID pdqid, intptr_t data, PRI datapri, TMO tmout)
{
	PDQCB	*p_pdqcb;
	bool_t	dspreq = false;
	ER		ercd;
	TCB		*p_tcb;

	LOG_TSND_PDQ_ENTER(pdqid, data, datapri, tmout);
	CHECK_DISPATCH();
	CHECK_PDQID(pdqid);
	CHECK_TMOUT(tmout);
	p_pdqcb = get_pdqcb(pdqid);
	CHECK_PAR(TMIN_DPRI <= datapri && datapri <= p_pdqcb->p_pdqinib->maxdpri);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ*/
	if (!queue_empty(&(p_pdqcb->rwait_queue))) {
		p_tcb = (TCB *)(p_pdqcb->rwait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		p_tcb->winfo_obj.pdq.data = data;
		p_tcb->winfo_obj.pdq.datapri = datapri;
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);
		ercd = E_OK;
	}
	else if (p_pdqcb->count < p_pdqcb->p_pdqinib->pdqcnt) {
		enqueue_pridata(p_pdqcb, data, datapri);
		T_RELEASE_OBJ_LOCK(p_pdqcb);
		ercd = E_OK;
	}   /* Хåեե뤫ļԤʤ */
	else if (tmout == TMO_POL) {
		T_RELEASE_OBJ_LOCK(p_pdqcb);
		ercd = E_TMOUT;
	}
	else {
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(p_pdqcb);
		my_p_runtsk->winfo_obj.pdq.data = data;
		my_p_runtsk->winfo_obj.pdq.datapri = datapri;
		my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_SPDQ);
		wobj_make_wait_tmout((WOBJCB *) p_pdqcb, tmout);
		T_RELEASE_NESTED_LOCK(my_p_runtsk->p_pcb);
		RELEASE_OBJ_LOCK(p_pdqcb);
		dispatch();
		ercd = my_p_runtsk->wercd;
		t_unlock_cpu();
	}

  error_exit:
	LOG_TSND_PDQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_tsnd_pdq */

/*
 *  ͥ٥ǡ塼μ
 */
#ifdef TOPPERS_rcv_pdq

ER
rcv_pdq(ID pdqid, intptr_t *p_data, PRI *p_datapri)
{
	PDQCB	*p_pdqcb;
	bool_t	dspreq = false;
	ER		ercd;
	TCB		*p_tcb;

	LOG_RCV_PDQ_ENTER(pdqid, p_data, p_datapri);
	CHECK_DISPATCH();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ */
	if (!queue_empty(&(p_pdqcb->swait_queue))) {
		/* Ԥ */
		p_tcb = (TCB *)(p_pdqcb->swait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		if (p_pdqcb->count > 0U) {
			dequeue_pridata(p_pdqcb, p_data, p_datapri);
			enqueue_pridata(p_pdqcb, p_tcb->winfo_obj.pdq.data, p_tcb->winfo_obj.pdq.datapri);
		}
		else {
			*p_data = p_tcb->winfo_obj.pdq.data;
			*p_datapri = p_tcb->winfo_obj.pdq.datapri;
		}
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);
		ercd = E_OK;
	}
	else if (p_pdqcb->count > 0U) {
		/* Хåե˥ǡꡤԤʤ */
		dequeue_pridata(p_pdqcb, p_data, p_datapri);
		T_RELEASE_OBJ_LOCK(p_pdqcb);
		ercd = E_OK;
	}
	else {
		/* ХåեԤʤ */
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(p_pdqcb);
		my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_RPDQ);
		make_wait();
		queue_insert_prev(&(p_pdqcb->rwait_queue), &(my_p_runtsk->task_queue));
		my_p_runtsk->p_wobjcb = (WOBJCB*)p_pdqcb;
		LOG_TSKSTAT(my_p_runtsk);
		T_RELEASE_NESTED_LOCK(my_p_runtsk->p_pcb);
		RELEASE_OBJ_LOCK(p_pdqcb);
		dispatch();
		ercd = my_p_runtsk->wercd;
		if (ercd == E_OK) {
			*p_data = my_p_runtsk->winfo_obj.pdq.data;
			*p_datapri = my_p_runtsk->winfo_obj.pdq.datapri;
		}
		t_unlock_cpu();
	}

  error_exit:
	LOG_RCV_PDQ_LEAVE(ercd, *p_data, *p_datapri);
	return(ercd);
}

#endif /* TOPPERS_rcv_pdq */

/*
 *  ͥ٥ǡ塼μʥݡ󥰡
 */
#ifdef TOPPERS_prcv_pdq

ER
prcv_pdq(ID pdqid, intptr_t *p_data, PRI *p_datapri)
{
	PDQCB	*p_pdqcb;
	bool_t	dspreq = false;
	ER		ercd;
	TCB		*p_tcb;

	LOG_PRCV_PDQ_ENTER(pdqid, p_data, p_datapri);
	CHECK_TSKCTX_UNL();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ */
	if (!queue_empty(&(p_pdqcb->swait_queue))) {
		/* Ԥ */
		p_tcb = (TCB *)(p_pdqcb->swait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		if (p_pdqcb->count > 0U) {
			dequeue_pridata(p_pdqcb, p_data, p_datapri);
			enqueue_pridata(p_pdqcb, p_tcb->winfo_obj.pdq.data, p_tcb->winfo_obj.pdq.datapri);
		}
		else {
			*p_data = p_tcb->winfo_obj.pdq.data;
			*p_datapri = p_tcb->winfo_obj.pdq.datapri;
		}
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		ercd = E_OK;
	}
	else if (p_pdqcb->count > 0U) {
		/* Хåե˥ǡꡤԤʤ */
		dequeue_pridata(p_pdqcb, p_data, p_datapri);
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);

  error_exit:
	LOG_PRCV_PDQ_LEAVE(ercd, *p_data, *p_datapri);
	return(ercd);
}

#endif /* TOPPERS_prcv_pdq */

/*
 *  ͥ٥ǡ塼μʥॢȤ
 */
#ifdef TOPPERS_trcv_pdq

ER
trcv_pdq(ID pdqid, intptr_t *p_data, PRI *p_datapri, TMO tmout)
{
	PDQCB	*p_pdqcb;
	bool_t	dspreq = false;
	ER		ercd;
	TCB		*p_tcb;

	LOG_TRCV_PDQ_ENTER(pdqid, p_data, p_datapri, tmout);
	CHECK_DISPATCH();
	CHECK_PDQID(pdqid);
	CHECK_TMOUT(tmout);
	p_pdqcb = get_pdqcb(pdqid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	/* δ֤Ϸ֤¹Ԥ뤿ᡤ˲ɤǤʤФʤʤ */
	if (!queue_empty(&(p_pdqcb->swait_queue))) {
		/* Ԥ */
		p_tcb = (TCB *)(p_pdqcb->swait_queue.p_next);
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_pdqcb);
		queue_delete((QUEUE *) p_tcb);
		if (p_pdqcb->count > 0U) {
			dequeue_pridata(p_pdqcb, p_data, p_datapri);
			enqueue_pridata(p_pdqcb, p_tcb->winfo_obj.pdq.data, p_tcb->winfo_obj.pdq.datapri);
		}
		else {
			*p_data = p_tcb->winfo_obj.pdq.data;
			*p_datapri = p_tcb->winfo_obj.pdq.datapri;
		}
		if (wait_complete(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
		T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);
		ercd = E_OK;
	}
	else if (p_pdqcb->count > 0U) {
		/* Хåե˥ǡꡤԤʤ */
		dequeue_pridata(p_pdqcb, p_data, p_datapri);
		T_RELEASE_OBJ_LOCK(p_pdqcb);
		ercd = E_OK;
	}   /* ХåեԤʤ */
	else if (tmout == TMO_POL) {
		T_RELEASE_OBJ_LOCK(p_pdqcb);
		ercd = E_TMOUT;
	}
	else {
		/* ХåեԤʤ */
		T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(p_pdqcb);
		my_p_runtsk->tstat = (TS_WAITING | TS_WAIT_RPDQ);
		make_wait_tmout(tmout);
		queue_insert_prev(&(p_pdqcb->rwait_queue), &(my_p_runtsk->task_queue));
		my_p_runtsk->p_wobjcb = (WOBJCB*)p_pdqcb;
		LOG_TSKSTAT(my_p_runtsk);
		T_RELEASE_NESTED_LOCK(my_p_runtsk->p_pcb);
		RELEASE_OBJ_LOCK(p_pdqcb);
		dispatch();
		ercd = my_p_runtsk->wercd;
		if (ercd == E_OK) {
			*p_data = my_p_runtsk->winfo_obj.pdq.data;
			*p_datapri = my_p_runtsk->winfo_obj.pdq.datapri;
		}
		t_unlock_cpu();
	}

  error_exit:
	LOG_TRCV_PDQ_LEAVE(ercd, *p_data, *p_datapri);
	return(ercd);
}

#endif /* TOPPERS_trcv_pdq */

/*
 *  ͥ٥ǡ塼κƽ
 */
#ifdef TOPPERS_ini_pdq

ER
ini_pdq(ID pdqid)
{
	PDQCB	*p_pdqcb;
	ER		ercd;
	bool_t	dspreq;

	LOG_INI_PDQ_ENTER(pdqid);
	CHECK_TSKCTX_UNL();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	dspreq = init_wait_queue(&(p_pdqcb->swait_queue));
	if (init_wait_queue(&(p_pdqcb->rwait_queue))) {
		dspreq = true;
	}
	p_pdqcb->count = 0U;
	p_pdqcb->p_head = NULL;
	p_pdqcb->unused = 0U;
	p_pdqcb->p_freelist = NULL;
	ercd = E_OK;
	T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_pdqcb, dspreq);

  error_exit:
	LOG_INI_PDQ_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_ini_pdq */

/*
 *  ͥ٥ǡ塼ξֻ
 */
#ifdef TOPPERS_ref_pdq

ER
ref_pdq(ID pdqid, T_RPDQ *pk_rpdq)
{
	PDQCB	*p_pdqcb;
	ER		ercd;

	LOG_REF_PDQ_ENTER(pdqid, pk_rpdq);
	CHECK_TSKCTX_UNL();
	CHECK_PDQID(pdqid);
	p_pdqcb = get_pdqcb(pdqid);

  retry:
	T_ACQUIRE_OBJ_LOCK(p_pdqcb);
	pk_rpdq->stskid = wait_tskid(&(p_pdqcb->swait_queue));
	pk_rpdq->rtskid = wait_tskid(&(p_pdqcb->rwait_queue));
	pk_rpdq->spdqcnt = p_pdqcb->count;
	ercd = E_OK;
	T_RELEASE_OBJ_LOCK(p_pdqcb);

  error_exit:
	LOG_REF_PDQ_LEAVE(ercd, pk_rpdq);
	return(ercd);
}

#endif /* TOPPERS_ref_pdq */
