/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 341 2009-08-02 15:01:13Z ertl-honda $
 */

/*
 * åװ¸⥸塼AT91SKYEYEѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"
#include "mp.h"
#include <stdlib.h>

/*
 *  str_ker() ǥޥץåǹԤ
 */
void
target_mprc_initialize(void)
{

}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  ARM¸ν
	 */
	core_initialize();
    
	/*
	 * Ƴߤγ׵ػߥե饰ػ
	 */
	my_tacb->idf = ~0U;

	/*
	 * ͥ٥ޥ0
	 */ 
	my_tacb->ipm = 0U;

	/*
	 * Ƥγߤޥ
	 */ 
	at91skyeye_disable_int(~0U);

	/*
	 * ٤Ƥγߤ
	 */
	at91skyeye_clear_int(~0U);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
	 */
	my_tacb->bitpat_cfgint = 0U;
    
	/*
	 *  target_fput_lot ǽˤʤ褦UART
	 */
	at91skyeye_init_uart(x_prc_index() + 1);
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  ARM¸νλ
	 */
	core_terminate();

	/*
	 *  ٤Ƥγߤޥ롥
	 */
	at91skyeye_disable_int(~0U);

	/*
	 *  ȯĶ¸νλ
	 */
	at91skyeye_exit();

	if (x_sense_mprc()) {
		exit(0);
	}
	else {
		while(1);
	}
}

/*
 *  ¹Իʬ۽ץ⥸塼Ѥ¬ѥޤνؿ
 */
void
perf_timer_initialize(intptr_t exinf)
{
}

/*
 *  륫󥿤μ
 */
void
cycle_counter_get(uint32_t *p_time)
{
	*p_time = cycle_counter_get_current();
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		at91skyeye_putc('\r');
	}
	at91skyeye_putc(c);
}

/*
 *  ׵饤°
 *
 *  FMPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask)
{
	assert(VALID_INTNO(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	my_tacb->bitpat_cfgint |= INTNO_BITPAT(INTNO_MASK(intno));
    
	/* 
	 * äߤػߤ
	 */    
	x_disable_int(intno);

	if ((intatr & TA_ENAINT) != 0U){
		(void)x_enable_int(intno);
	}    
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "Processor %d : Unregistered Interrupt occurs.", prc_id);
	target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */


extern void start_master(void);

/*
 *  ѥΥȥåץ롼󤫤ƤӽФ롥
 *  sta_ker()ƤӽФƥͥ򥹥Ȥ롥 
 */
int
main(void)
{
	start_master();
	return 1;
}