/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 91 2009-01-25 16:50:43Z ertl-honda $
 */

/*
 * åȰ¸⥸塼NaviEngineѡ
 */
#include "kernel_impl.h"
#include <sil.h>

/*
 *  str_ker() ǥޥץåǹԤ
 */
void
target_mprc_initialize(void)
{
	/* MPCore¸Ǥν */
	chip_mprc_initialize();

	/* NaviEngine  MPCore Status ν */
	sil_wrw_mem((void *)NAVIENGINE_MPCORE_STATUS, 0x00);
}

/*
 * Υ١ɥ쥹ȥ
 */
#define SDRAM_PADDR 0x80000000
#define SDRAM_SIZE  0x10000000 /* 256MB */

/*
 * ޥåפνchip¸ƤӽФ
 * Ʊ˥åͭˤ
 */
void
target_mmu_init(void)
{
	MEMORY_ATTRIBUTE m_attribute;

	/*
	 *  Enable caching for the SDRAM
	 */
	m_attribute.pa   = SDRAM_PADDR;
	m_attribute.va   = m_attribute.pa;
	m_attribute.size = SDRAM_SIZE;
	m_attribute.s    = 1;		  /* ͭ		 */
	m_attribute.ap   = 3;		  /* ե륢 */
	m_attribute.tex  = 1;		  /* Outer and Inner */
	m_attribute.c    = 1;		  /* Inner Write-Back, Write Allocate */ 
	m_attribute.b    = 1;

	mmu_map_memory(&m_attribute);

	/*
	 *  ٥ơ֥0x0000֤ᡤSDRAM
	 *  0x0000֤ 
	 */
	m_attribute.pa   = 0x81000000;
	m_attribute.va   = 0x00000000;   
	m_attribute.size = 0x10000000 - 0x01000000;
	m_attribute.ap   = 3;          /* ե륢 */
	m_attribute.tex  = 1;          /* Outer and Inner */
	m_attribute.c    = 1;          /* Inner Write-Back, Write Allocate */ 
	m_attribute.b    = 1;

	mmu_map_memory(&m_attribute);
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 * åװ¸ν
	 */
	chip_initialize();
        
	/*
	 *  UART
	 */
#ifdef G_SYSLOG
	if (x_sense_mprc()) {
		naviengine_uart_init();
	}
#else
	naviengine_uart_init();
#endif /* G_SYSLOG */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  åװ¸νλ
	 */
	chip_exit();

	/*
	 *  ȯĶ¸νλ
	 */
	naviengine_exit();

	while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		naviengine_uart_putc('\r');
	}
	naviengine_uart_putc(c);
}

/*
 *  ¹Իʬ۽ץ⥸塼Ѥ¬ѥޤνؿ
 */
void
perf_timer_initialize(intptr_t exinf)
{
	scu_counter_init();
}

/*
 *  ¹Իʬ۽ץ⥸塼ѤΥ󥿤ˤ¬
 */
void
perf_timer_get(uint32_t *p_time)
{
	*p_time = scu_counter_get_current();
}

/*
 *  ¹Իʬ۽ץ⥸塼ѤΥ󥿤ˤ¬̤ñѴ
 *  nsecѴ 
 */
uint32_t
perf_timer_conv_tim(uint32_t time)
{
	return (time * 1000) / NAVIENGINE_CORE_CLK;
}
